package cl.pleiad.xcutreport.actions;

import java.lang.Math;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import cl.pleiad.xcutreport.AdviceListener;


public class OutputSelectionDialog extends Dialog {

	String tmpFile = AdviceListener.extendedRW.getFileName();

	public OutputSelectionDialog(Shell parent, int style) {
		super(parent, style);
	}

  /**
   * Makes the dialog visible.
   * 
   * @return
   */
	public void open() {
		Shell parent = getParent();

		final Shell shell =
			new Shell(parent, SWT.TITLE | SWT.BORDER | SWT.APPLICATION_MODAL);
		shell.setText("Crosscut plugin configuration Dialog");
		shell.setLayout(new GridLayout(3, false));

		final Button buttonOutput2Console = new Button(shell, SWT.CHECK);
		buttonOutput2Console.setText("Output to console    ");
		buttonOutput2Console.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING));
		buttonOutput2Console.setSelection( AdviceListener.extendedRW.consoleOutput() );
		
		Label nothing = new Label(shell, SWT.NULL);
		nothing.setText("");
		nothing = new Label(shell, SWT.NULL);
		nothing.setText("");

		final Button buttonOutput2File = new Button(shell, SWT.CHECK);
		buttonOutput2File.setText("Output to file:");
		buttonOutput2File.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING));
		buttonOutput2File.setSelection( AdviceListener.extendedRW.fileOutput() );
		
		final Label outfilename = new Label(shell, SWT.NULL);
		outfilename.setText(tmpFile.substring(tmpFile.lastIndexOf('/')+1));
		
		final Button buttonModifyFile = new Button(shell, SWT.PUSH);
		buttonModifyFile.setText("Change Output File");
		buttonModifyFile.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));
		buttonModifyFile.setEnabled( AdviceListener.extendedRW.fileOutput() );

		nothing = new Label(shell, SWT.NULL);
		nothing.setText("");
		nothing = new Label(shell, SWT.NULL);
		nothing.setText("");
		
		final Button buttonOK = new Button(shell, SWT.PUSH);
		buttonOK.setText("Ok");
		buttonOK.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));
		buttonOK.setFocus();

		buttonOutput2Console.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {}
		});

		buttonOutput2File.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				if( buttonOutput2File.getSelection() ) {
					String tmp = GetFile(shell, tmpFile.substring(tmpFile.lastIndexOf('/')+1));
					if( tmp != null ) {
						tmpFile = tmp;
						outfilename.setText(tmpFile.substring(tmpFile.lastIndexOf('/')+1));
						buttonModifyFile.setEnabled(true);
					} else	// Cancelled
						buttonOutput2File.setSelection(false);
				} 
			}
		});
		
		buttonModifyFile.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				String tmp = GetFile(shell, tmpFile.substring(tmpFile.lastIndexOf('/')+1));
				if( tmp != null ) {
					tmpFile = tmp;
					outfilename.setText(tmpFile.substring(tmpFile.lastIndexOf('/')+1));
				}
			}
		});

		buttonOK.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				AdviceListener.extendedRW.bConsoleOutput = buttonOutput2Console.getSelection();		
				AdviceListener.extendedRW.bFileOutput = buttonOutput2File.getSelection();

				if( buttonOutput2File.getSelection() )
					AdviceListener.extendedRW.setFileName(tmpFile);
				shell.dispose();
			}
		});

		shell.addListener(SWT.Traverse, new Listener() {
			public void handleEvent(Event event) {
				if(event.detail == SWT.TRAVERSE_ESCAPE)
					event.doit = false;
			}
		});
		shell.pack();
		shell.open();
		Display display = parent.getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	// returns null when input is cancelled
	final String GetFile(Shell shell, String startingFile) {
		FileDialog fd = new FileDialog(shell, SWT.SAVE);
		fd.setText("Select Output File");
		fd.setFileName(startingFile);
		return fd.open();
	}
}
