package cl.pleiad.xcutreport.actions;

import org.eclipse.ajdt.core.builder.AJBuilder;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import cl.pleiad.xcutreport.AdviceListener;

/**
 * Our sample action implements workbench action delegate.
 * The action proxy will be created by the workbench and
 * shown in the UI. When the user tries to use the action,
 * this delegate will be created and execution will be 
 * delegated to it.
 * @see IWorkbenchWindowActionDelegate
 */
public class ToolbarAction implements IWorkbenchWindowActionDelegate {
	public static IWorkbenchWindow window;

	/**
	 * The constructor.
	 */
	public ToolbarAction() {}

	/**
	 * The action has been activated. The argument of the method
	 * represents the 'real' action sitting in the workbench UI.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action) {
		OutputSelectionDialog dialog = new OutputSelectionDialog(window.getShell(), SWT.SYSTEM_MODAL);
		dialog.open();

		if( AdviceListener.extendedRW.consoleOutput() || AdviceListener.extendedRW.fileOutput() )
			AJBuilder.addAdviceListener(AdviceListener.getInstance());
		else
			AJBuilder.removeAdviceListener(AdviceListener.getInstance());
	}


	/**
	 * Selection in the workbench has been changed. We 
	 * can change the state of the 'real' action here
	 * if we want, but this can only happen after 
	 * the delegate has been created.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {}

	/**
	 * We can use this method to dispose of any system
	 * resources we previously allocated.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {}

	/**
	 * We will cache window object in order to
	 * be able to provide parent shell for the message dialog.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}
}
